HelpBot Assistant

How can I help you?

Paste Clean-up in EJ2 JavaScript Block Editor control

15 Dec 202516 minutes to read

The Block Editor control provides robust paste clean-up functionalities to ensure that pasted content integrates seamlessly and maintains styling and structural consistency. This feature helps remove unwanted formatting, scripts, and elements copied from external sources like web pages or word processors.

You can configure the paste behavior using the pasteCleanupSettings property, which allows you to define how content is handled when pasted into the editor.

Configuring allowed styles

The allowedStyles property lets you define which CSS styles are permitted in pasted content. Any style not in this list is stripped out, ensuring that only desired visual attributes are preserved.

By default, the following styles are allowed:

[‘font-weight’, ‘font-style’, ‘text-decoration’, ‘text-transform’].

In the below example, only font-weight and font-style styles will be retained from the pasted content. All other inline styles will be removed.

const editor = new BlockEditor({
    pasteCleanupSettings: {
        allowedStyles: ['font-weight', 'font-style']
    }
});

Setting denied tags

The deniedTags property specifies a list of HTML tags to be removed from pasted content. This is useful for stripping potentially problematic elements like <script> or <iframe> tags. By default, this property is an empty array, so no tags are removed.

In the below example, any <script> or <iframe> tags found in the pasted content will be removed, preventing unwanted behavior or styling issues.

const editor = new BlockEditor({
    pasteCleanupSettings: {
        deniedTags: ['script', 'iframe']
    }
});

Below example demonstrates the usage of paste settings that allows only specific styles and also removes the specific tags from the pasted content.

// Initialize BlockEditor with paste cleanup settings
var blockEditor = new ej.blockeditor.BlockEditor({
    blocks: [
        {
            id: 'demo-block',
            blockType: 'Paragraph'
        }
    ],
    // Configure paste cleanup settings
    pasteCleanupSettings: {
        allowedStyles: ['text-decoration'],
        deniedTags: ['script', 'iframe']
    },
    afterPasteCleanup: function(args) {
        displayOutput('After Paste Event: Processed content length: ' + args.content.length + ' characters');
    }
});

blockEditor.appendTo('#blockeditor');

displayOutput('Paste Cleanup Settings Active:\n- Allowed Styles: [\'text-decoration\']\n- Denied Tags: [\'script\', \'iframe\']\n\nCopy content from the test area above and paste it into the editor to see the cleanup in action.');

// Output helper function
function displayOutput(message) {
    var outputDiv = document.getElementById('output');
    if (outputDiv) {
        outputDiv.textContent = message;
    }
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 - BlockEditor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet"/>
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-blockeditor/styles/tailwind3.css" rel="stylesheet" />

    <!--style reference from app-->
    <link href="index.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

<div id="container">
    <div id="blockeditor"></div>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <script> console.log('This script should be removed'); </script>
                <iframe src="about:blank" width="100" height="50"></iframe>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
</div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <style>
        #container {
            margin: 50px;
            gap: 20px;
            display: flex;
            flex-direction: column;
            align-items: center;
        }
    </style>

    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Disable Keep format

By default, the editor retains the formatting of pasted content (e.g., bold, italics, links). You can disable this by setting the keepFormat property to false. When disabled, the editor primarily pastes content as plain text, regardless of the allowedStyles configuration.

const editor = new BlockEditor({
    pasteCleanupSettings: {
        keepFormat: false
    }
});

Allowing plain text

To paste content as plain text, stripping all HTML tags and inline styles, set the plainText property to true in pasteCleanupSettings. This ensures that only raw text is inserted, which is ideal for maintaining strict content consistency. By default, this property is false.

const editor = new BlockEditor({
    pasteCleanupSettings: {
        plainText: true
    }
});

Below example demonstrates the usage of paste settings that disables the keep format and allows plain text.

// Initialize BlockEditor with paste cleanup settings
var blockEditor = new ej.blockeditor.BlockEditor({
    blocks: [
        {
            id: 'demo-block',
            blockType: 'Paragraph'
        }
    ],
    // Configure paste cleanup settings
    pasteCleanupSettings: {
        keepFormat: false,
        plainText: true,
    },
    afterPasteCleanup: function(args) {
        displayOutput('After Paste Event: Processed content length: ' + args.content.length + ' characters');
    }
});

blockEditor.appendTo('#blockeditor');

displayOutput('Paste Cleanup Settings Active:\n- Keep Format: false\n- Plain Text: true\n\nCopy content from the test area above and paste it into the editor to see the cleanup in action.');

// Output helper function
function displayOutput(message) {
    var outputDiv = document.getElementById('output');
    if (outputDiv) {
        outputDiv.textContent = message;
    }
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 - BlockEditor</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-popups/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-inputs/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-navigations/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet"/>
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.2.3/ej2-blockeditor/styles/tailwind3.css" rel="stylesheet" />

    <!--style reference from app-->
    <link href="index.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>

<div id="container">
    <div id="blockeditor"></div>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
</div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <style>
        #container {
            margin: 50px;
            gap: 20px;
            display: flex;
            flex-direction: column;
            align-items: center;
        }
    </style>

    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Events

The Block Editor provides events to monitor and interact with the paste action.

Name Args Description
beforePasteCleanup BeforePasteCleanupEventArgs Triggers before the content is pasted into the editor.
afterPasteCleanup AfterPasteCleanupEventArgs Triggers after the content is pasted into the editor.

Below snippet demonstrates how to configure above events in the editor.

const editor = new BlockEditor({
    beforePasteCleanup: onBeforePasteCleanup()
});
const editor = new BlockEditor({
    afterPasteCleanup: onAfterPasteCleanup()
});

HelpBot Assistant

How can I help you?

Paste Clean-up in Vue Block Editor component

3 Feb 202620 minutes to read

The Block Editor component provides robust paste clean-up functionalities to ensure that pasted content integrates seamlessly and maintains styling and structural consistency. This feature helps remove unwanted formatting, scripts, and elements copied from external sources like web pages or word processors.

You can configure the paste behavior using the pasteCleanupSettings property, which allows you to define how content is handled when pasted into the editor.

Configuring allowed styles

The allowedStyles property lets you define which CSS styles are permitted in pasted content. Any style not in this list is stripped out, ensuring that only desired visual attributes are preserved.

By default, the following styles are allowed:

[‘font-weight’, ‘font-style’, ‘text-decoration’, ‘text-transform’].

In the below example, only font-weight and font-style styles will be retained from the pasted content. All other inline styles will be removed.

Setting denied tags

The deniedTags property specifies a list of HTML tags to be removed from pasted content. This is useful for stripping potentially problematic elements like <script> or <iframe> tags. By default, this property is an empty array, so no tags are removed.

In the below example, any <script> or <iframe> tags found in the pasted content will be removed, preventing unwanted behavior or styling issues.

<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData" :pasteCleanupSettings="pasteCleanupSettings" :afterPasteCleanup="afterPasteCleanup"></ejs-blockeditor>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <script> console.log('This script should be removed'); </script>
                <iframe src="about:blank" width="100" height="50"></iframe>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor, AfterPasteCleanupEventArgs } from "@syncfusion/ej2-vue-blockeditor";

const blocksData = [
    {
        id: 'demo-block',
        blockType: 'Paragraph'
    }
];
const pasteCleanupSettings= {
    allowedStyles: ['text-decoration'],
    deniedTags: ['script', 'iframe']
};
const afterPasteCleanup= (args: AfterPasteCleanupEventArgs) => {
    displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
};
const displayOutput=(message) => {
    const outputDiv = document.getElementById('output');
    if (outputDiv) {
        outputDiv.textContent = message;
    }
};
onMounted(() => {
      displayOutput(`Paste Cleanup Settings Active: 
      - Keep Format: ${pasteSettings.keepFormat} 
      - Plain Text: ${pasteSettings.plainText} 

      Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    });

</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData" :pasteCleanupSettings="pasteCleanupSettings" :afterPasteCleanup="afterPasteCleanup"></ejs-blockeditor>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <script> console.log('This script should be removed'); </script>
                <iframe src="about:blank" width="100" height="50"></iframe>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
  </div>
</template>

<script>
import { BlockEditorComponent } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData : [
          {
              id: 'demo-block',
              blockType: 'Paragraph'
          }
      ],
      pasteCleanupSettings: {
          allowedStyles: ['text-decoration'],
          deniedTags: ['script', 'iframe']
      },
      afterPasteCleanup: (args) => {
          this.displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
      }
    };
  },
  methods: {
    displayOutput :function(message) {
      var outputDiv = document.getElementById('output');
      if (outputDiv) {
          outputDiv.textContent = message;
      }
    }
  },
  mounted() {
    this.displayOutput(`Paste Cleanup Settings Active:
      - Allowed Styles: ['text-decoration']
      - Denied Tags: ['script', 'iframe']

      Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>

Disable Keep format

By default, the editor retains the formatting of pasted content (e.g., bold, italics, links). You can disable this by setting the keepFormat property to false. When disabled, the editor primarily pastes content as plain text, regardless of the allowedStyles configuration.

Allowing plain text

To paste content as plain text, stripping all HTML tags and inline styles, set the plainText property to true in pasteCleanupSettings. This ensures that only raw text is inserted, which is ideal for maintaining strict content consistency. By default, this property is false.

<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData" :pasteCleanupSettings="pasteCleanupSettings" :afterPasteCleanup="afterPasteCleanup"></ejs-blockeditor>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
  </div>
</template>

<script setup>
import { BlockEditorComponent as EjsBlockeditor  } from "@syncfusion/ej2-vue-blockeditor";

const blocksData = [
    {
        blockType: 'Paragraph'
    }
];
const pasteCleanupSettings= {
        keepFormat: false,
        plainText: true,
    };
const afterPasteCleanup= (args) => {
    displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
};

const displayOutput=(message) => {
    const outputDiv = document.getElementById('output');
    if (outputDiv) {
        outputDiv.textContent = message;
    }
}

onMounted(() => {
      displayOutput(`Paste Cleanup Settings Active: 
      - Keep Format: ${pasteSettings.keepFormat} 
      - Plain Text: ${pasteSettings.plainText} 

      Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    });
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>
<template>
  <div id='container'>
    <ejs-blockeditor :blocks="blocksData" :pasteCleanupSettings="pasteCleanupSettings" :afterPasteCleanup="afterPasteCleanup"></ejs-blockeditor>
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
  </div>
</template>

<script>
import { BlockEditorComponent, ContentType, AfterPasteEventArgs  } from "@syncfusion/ej2-vue-blockeditor";

export default {
  components: {
    'ejs-blockeditor': BlockEditorComponent,
  },
  data() {
    return {
      blocksData : [
          {
              blockType: 'Paragraph'
          }
      ],
      pasteCleanupSettings: {
          keepFormat: false,
          plainText: true,
      },
      afterPasteCleanup: (args) => {
          this.displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
      }
    };
  },
  methods: {
    displayOutput :function(message) {
      var outputDiv = document.getElementById('output');
      if (outputDiv) {
          outputDiv.textContent = message;
      }
    }
  },
  mounted() {
    this.displayOutput(`Paste Cleanup Settings Active: 
      - Keep Format: ${pasteSettings.keepFormat} 
      - Plain Text: ${pasteSettings.plainText} 

      Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
  }
};
</script>

<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css';
  @import '../node_modules/@syncfusion/ej2-blockeditor/styles/tailwind3.css';
</style>

Events

The Block Editor provides events to monitor and interact with the paste action.

Name Args Description
beforePasteCleanup BeforePasteCleanupEventArgs Triggers before the content is pasted into the editor.
afterPasteCleanup AfterPasteCleanupEventArgs Triggers after the content is pasted into the editor.

Below snippet demonstrates how to configure above events in the editor.

<ejs-blockeditor (beforePasteCleanup)="onBeforePasteCleanup()" />
<ejs-blockeditor (afterPasteCleanup)="onAfterPasteCleanup()" />

HelpBot Assistant

How can I help you?

Paste Clean-up in React Block Editor component

15 Dec 202518 minutes to read

The Block Editor component provides robust paste clean-up functionalities to ensure that pasted content integrates seamlessly and maintains styling and structural consistency. This feature helps remove unwanted formatting, scripts, and elements copied from external sources like web pages or word processors.

You can configure the paste behavior using the pasteCleanupSettings property, which allows you to define how content is handled when pasted into the editor.

Configuring allowed styles

The allowedStyles property lets you define which CSS styles are permitted in pasted content. Any style not in this list is stripped out, ensuring that only desired visual attributes are preserved.

By default, the following styles are allowed:

[‘font-weight’, ‘font-style’, ‘text-decoration’, ‘text-transform’].

In the below example, only font-weight and font-style styles will be retained from the pasted content. All other inline styles will be removed.

<BlockEditorComponent pasteCleanupSettings={{ allowedStyles: ['font-weight', 'font-style'] }}></BlockEditorComponent>

Setting denied tags

The deniedTags property specifies a list of HTML tags to be removed from pasted content. This is useful for stripping potentially problematic elements like <script> or <iframe> tags. By default, this property is an empty array, so no tags are removed.

In the below example, any <script> or <iframe> tags found in the pasted content will be removed, preventing unwanted behavior or styling issues.

<BlockEditorComponent pasteCleanupSettings={{ deniedTags: ['script', 'iframe'] }}></BlockEditorComponent>

Below example demonstrates the usage of paste settings that allows only specific styles and also removes the specific tags from the pasted content.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent } from '@syncfusion/ej2-react-blockeditor';

function App() {
    
    const blocksData = [
    {
        blockType: 'Paragraph'
    }
];

    const handleAfterPaste = (args) => {
        displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    };

    // Output helper function
    const displayOutput = (message) => {
        const outputDiv = document.getElementById('output');
        if (outputDiv) {
            outputDiv.textContent = message;
        }
    };

    React.useEffect(() => {
        displayOutput(`Paste Cleanup Settings Active:
- Allowed Styles: ['text-decoration']
- Denied Tags: ['script', 'iframe']

Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }, []);

    return (
       <div>
            <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div className="test-content">
                <div id="sampleContent" contentEditable={true}>
      <h2 style=>
        Formatted Heading
      </h2>
      <p style=>
        This is a <span style=>bold paragraph</span> with{' '}
        <span style=>italic text</span> and{' '}
        <span style=>underlined content</span>.
      </p>
      <iframe src="about:blank" width="100" height="50" />
      <div style=>
        <span style=>Heavy text</span> and{' '}
        <span style=>colored text</span>
      </div>
    </div>
        </div>
    </div>
        <BlockEditorComponent
            id="blockeditor"
            blocks={blocksData}
            pasteCleanupSettings=
            afterPasteCleanup={handleAfterPaste}
        ></BlockEditorComponent>
          <div id="output"></div>
                </div>
    );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, AfterPasteCleanupEventArgs } from '@syncfusion/ej2-react-blockeditor';

function App() {
    
    const blocksData = [
        {
            blockType: 'Paragraph'
        }
    ];

    const handleAfterPaste = (args: AfterPasteCleanupEventArgs) => {
        displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    };

    // Output helper function
    const displayOutput = (message: string) => {
        const outputDiv = document.getElementById('output');
        if (outputDiv) {
            outputDiv.textContent = message;
        }
    };

    React.useEffect(() => {
        displayOutput(`Paste Cleanup Settings Active:
- Allowed Styles: ['text-decoration']
- Denied Tags: ['script', 'iframe']

Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }, []);

    return (
        <div>
            <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div className="test-content">
                <div id="sampleContent" contentEditable={true}>
      <h2 style=>
        Formatted Heading
      </h2>
      <p style=>
        This is a <span style=>bold paragraph</span> with{' '}
        <span style=>italic text</span> and{' '}
        <span style=>underlined content</span>.
      </p>
      <iframe src="about:blank" width="100" height="50" />
      <div style=>
        <span style=>Heavy text</span> and{' '}
        <span style=>colored text</span>
      </div>
    </div>
        </div>
    </div>
        <BlockEditorComponent
            id="blockeditor"
            blocks={blocksData}
            pasteCleanupSettings=
            afterPasteCleanup={handleAfterPaste}
        ></BlockEditorComponent>
                <div id="output"></div>
                </div>
    );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Disable Keep format

By default, the editor retains the formatting of pasted content (e.g., bold, italics, links). You can disable this by setting the keepFormat property to false. When disabled, the editor primarily pastes content as plain text, regardless of the allowedStyles configuration.

<BlockEditorComponent pasteCleanupSettings={{ keepFormat: false }}></BlockEditorComponent>

Allowing plain text

To paste content as plain text, stripping all HTML tags and inline styles, set the plainText property to true in pasteCleanupSettings. This ensures that only raw text is inserted, which is ideal for maintaining strict content consistency. By default, this property is false.

<BlockEditorComponent pasteCleanupSettings={{ plainText: true }}></BlockEditorComponent>

Below example demonstrates the usage of paste settings that disables the keep format and allows plain text.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent } from '@syncfusion/ej2-react-blockeditor';

function App() {
  
const blocksData = [
    {
        blockType: 'Paragraph'
    }
];
    const handleAfterPaste = (args) => {
        displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    };

    // Output helper function
    const displayOutput = (message) => {
        const outputDiv = document.getElementById('output');
        if (outputDiv) {
            outputDiv.textContent = message;
        }
    };

    React.useEffect(() => {
        displayOutput(`Paste Cleanup Settings Active:
- Keep Format: false
- Plain Text: true

Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }, []);

    return (
              <div id="controls">
      <h4>Test Content to Copy and Paste:</h4>
      <div className="test-content">
        <div id="sampleContent" contentEditable={true}>
          <h2 style=>
            Formatted Heading
          </h2>
          <p style=>
            This is a <span style=>bold paragraph</span> with{' '}
            <span style=>italic text</span> and{' '}
            <span style=>underlined content</span>.
          </p>
          <div style=>
            <span style=>Heavy text</span> and{' '}
            <span style=>colored text</span>
          </div>
        </div>
      </div>
        <BlockEditorComponent
            id="blockeditor"
            blocks={blocksData}
            pasteCleanupSettings=
            afterPasteCleanup={handleAfterPaste}
        ></BlockEditorComponent>
         <div id="output"></div>
    </div>
    );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { BlockEditorComponent, AfterPasteCleanupEventArgs } from '@syncfusion/ej2-react-blockeditor';

function App() {
  
    const blocksData = [
        {
          blockType: 'Paragraph'
        }
    ];
    const handleAfterPaste = (args: AfterPasteCleanupEventArgs) => {
        displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    };

    // Output helper function
    const displayOutput = (message: string) => {
        const outputDiv = document.getElementById('output');
        if (outputDiv) {
            outputDiv.textContent = message;
        }
    };

    React.useEffect(() => {
        displayOutput(`Paste Cleanup Settings Active:
- Keep Format: false
- Plain Text: true

Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }, []);

    return (
         <div id="controls">
      <h4>Test Content to Copy and Paste:</h4>
      <div className="test-content">
        <div id="sampleContent" contentEditable={true}>
          <h2 style=>
            Formatted Heading
          </h2>
          <p style=>
            This is a <span style=>bold paragraph</span> with{' '}
            <span style=>italic text</span> and{' '}
            <span style=>underlined content</span>.
          </p>
          <div style=>
            <span style=>Heavy text</span> and{' '}
            <span style=>colored text</span>
          </div>
        </div>
      </div>
        <BlockEditorComponent
            id="blockeditor"
            blocks={blocksData}
            pasteCleanupSettings=
            afterPasteCleanup={handleAfterPaste}
        ></BlockEditorComponent>
         <div id="output"></div>
    </div>
    );
}

export default App;
ReactDOM.render(<App />, document.getElementById('container'));

Events

The Block Editor provides events to monitor and interact with the paste action.

Name Args Description
beforePasteCleanup BeforePasteCleanupEventArgs Triggers before the content is pasted into the editor.
afterPasteCleanup AfterPasteCleanupEventArgs Triggers after the content is pasted into the editor.

Below snippet demonstrates how to configure above events in the editor.

const editor = new BlockEditor({
    beforePasteCleanup: onBeforePasteCleanup()
});
const editor = new BlockEditor({
    afterPasteCleanup: onAfterPasteCleanup()
});

HelpBot Assistant

How can I help you?

Paste Clean-up in Angular Block Editor component

18 Dec 202515 minutes to read

The Block Editor component provides robust paste clean-up functionalities to ensure that pasted content integrates seamlessly and maintains styling and structural consistency. This feature helps remove unwanted formatting, scripts, and elements copied from external sources like web pages or word processors.

You can configure the paste behavior using the pasteCleanupSettings property, which allows you to define how content is handled when pasted into the editor.

Configuring allowed styles

The allowedStyles property lets you define which CSS styles are permitted in pasted content. Any style not in this list is stripped out, ensuring that only desired visual attributes are preserved.

By default, the following styles are allowed:

[‘font-weight’, ‘font-style’, ‘text-decoration’, ‘text-transform’].

In the below example, only font-weight and font-style styles will be retained from the pasted content. All other inline styles will be removed.

import { BlockEditorModule } from '@syncfusion/ej2-angular-blockeditor';
import { Component } from '@angular/core';

@Component({
    imports: [ BlockEditorModule ],
    standalone: true,
    selector: 'app-root',
    template: `<!-- To Render BlockEditor component. -->
    <div class="container" style="width: 40px; margin: 50px auto;">
        <ejs-blockeditor [pasteCleanupSettings]="pasteCleanupSettings" />
    </div>`
})

export class AppComponent {
    pasteCleanupSettings: {
        allowedStyles: ['font-weight', 'font-style']
    }
}

Setting denied tags

The deniedTags property specifies a list of HTML tags to be removed from pasted content. This is useful for stripping potentially problematic elements like <script> or <iframe> tags. By default, this property is an empty array, so no tags are removed.

In the below example, any <script> or <iframe> tags found in the pasted content will be removed, preventing unwanted behavior or styling issues.

import { BlockEditorModule } from '@syncfusion/ej2-angular-blockeditor';
import { Component } from '@angular/core';

@Component({
    imports: [ BlockEditorModule ],
    standalone: true,
    selector: 'app-root',
    template: `<!-- To Render BlockEditor component. -->
    <div class="container" style="width: 40px; margin: 50px auto;">
        <ejs-blockeditor [pasteCleanupSettings]="pasteCleanupSettings" />
    </div>`
})

export class AppComponent {
    pasteCleanupSettings: {
        deniedTags: ['script', 'iframe']
    }
}

Below example demonstrates the usage of paste settings that allows only specific styles and also removes the specific tags from the pasted content.

import { Component } from '@angular/core';
import { BlockEditorModule } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, AfterPasteCleanupEventArgs } from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})

// Initialize BlockEditor with paste cleanup settings
export class AppComponent {
    public output = '';
    public blockData: BlockModel[] = [
        {
            blockType: 'Paragraph'
        }
    ];
    // Configure paste cleanup settings
    public pasteCleanupSettings = {
        allowedStyles: ['text-decoration'],
        deniedTags: ['script', 'iframe']
    };
    public handleAfterPaste = (args: AfterPasteCleanupEventArgs) => {
        this.displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    }

    ngOnInit(): void {
        this.displayOutput(`Paste Cleanup Settings Active:
        - Allowed Styles: ['text-decoration']
        - Denied Tags: ['script', 'iframe']

        Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }

    // Output helper function
    displayOutput(message: string): void {
        this.output = message;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" [blocks]="blockData" [pasteCleanupSettings]="pasteCleanupSettings" (afterPasteCleanup)="handleAfterPaste($event)" />
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <script> console.log('This script should be removed'); </script>
                <iframe src="about:blank" width="100" height="50"></iframe>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
</div>

Disable Keep format

By default, the editor retains the formatting of pasted content (e.g., bold, italics, links). You can disable this by setting the keepFormat property to false. When disabled, the editor primarily pastes content as plain text, regardless of the allowedStyles configuration.

import { BlockEditorModule } from '@syncfusion/ej2-angular-blockeditor';
import { Component } from '@angular/core';

@Component({
    imports: [ BlockEditorModule ],
    standalone: true,
    selector: 'app-root',
    template: `<!-- To Render BlockEditor component. -->
    <div class="container" style="width: 40px; margin: 50px auto;">
        <ejs-blockeditor [pasteCleanupSettings]="pasteCleanupSettings" />
    </div>`
})

export class AppComponent {
    pasteCleanupSettings: {
        keepFormat: false
    }
}

Allowing plain text

To paste content as plain text, stripping all HTML tags and inline styles, set the plainText property to true in pasteCleanupSettings. This ensures that only raw text is inserted, which is ideal for maintaining strict content consistency. By default, this property is false.

import { BlockEditorModule } from '@syncfusion/ej2-angular-blockeditor';
import { Component } from '@angular/core';

@Component({
    imports: [ BlockEditorModule ],
    standalone: true,
    selector: 'app-root',
    template: `<!-- To Render BlockEditor component. -->
    <div class="container" style="width: 40px; margin: 50px auto;">
        <ejs-blockeditor [pasteCleanupSettings]="pasteCleanupSettings" />
    </div>`
})

export class AppComponent {
    pasteCleanupSettings: {
        plainText: true
    }
}

Below example demonstrates the usage of paste settings that disables the keep format and allows plain text.

import { Component } from '@angular/core';
import { BlockEditorModule } from "@syncfusion/ej2-angular-blockeditor";
import { BlockModel, AfterPasteCleanupEventArgs } from "@syncfusion/ej2-blockeditor";

@Component({
    imports: [BlockEditorModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.component.html'
})

// Initialize BlockEditor with paste cleanup settings
export class AppComponent {
    public output = '';
    public blockData: BlockModel[] = [
        {
            blockType: 'Paragraph'
        }
    ];
    // Configure paste cleanup settings
    public pasteCleanupSettings = {
        keepFormat: false,
        plainText: true
    };
    public handleAfterPaste = (args: AfterPasteCleanupEventArgs) => {
        this.displayOutput(`After Paste Event: Processed content length: ${args.content.length} characters`);
    }

    ngOnInit(): void {
       this.displayOutput(`Paste Cleanup Settings Active:
        - Keep Format: false
        - Plain Text: true

        Copy content from the test area above and paste it into the editor to see the cleanup in action.`);
    }

    // Output helper function
    displayOutput(message: string): void {
        this.output = message;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
<div id="container">
    <ejs-blockeditor id="blockeditor" [blocks]="blockData" [pasteCleanupSettings]="pasteCleanupSettings" (afterPasteCleanup)="handleAfterPaste($event)" />
    <div id="controls">
        <h4>Test Content to Copy and Paste:</h4>
        <div class="test-content">
            <div id="sampleContent" contenteditable="true">
                <h2 style="color: red; font-weight: bold; font-size: 24px;">Formatted Heading</h2>
                <p style="background-color: yellow; font-style: italic;">
                    This is a <span style="font-weight: bold;">bold paragraph</span> with 
                    <span style="color: blue; font-style: italic;">italic text</span> and 
                    <span style="text-decoration: underline;">underlined content</span>.
                </p>
                <div style="border: 1px solid black; padding: 10px;">
                    <span style="font-weight: 600;">Heavy text</span> and 
                    <span style="color: green; font-size: 18px;">colored text</span>
                </div>
            </div>
        </div>
        <div id="output"></div>
    </div>
</div>

Events

The Block Editor provides events to monitor and interact with the paste action.

Name Args Description
beforePasteCleanup BeforePasteCleanupEventArgs Triggers before the content is pasted into the editor.
afterPasteCleanup AfterPasteCleanupEventArgs Triggers after the content is pasted into the editor.

Below snippet demonstrates how to configure above events in the editor.

<ejs-blockeditor (beforePasteCleanup)="onBeforePasteCleanup()" />
<ejs-blockeditor (afterPasteCleanup)="onAfterPasteCleanup()" />